package com.usky.demo.service.job;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.usky.demo.Globals;
import com.usky.demo.service.config.mqtt.MqttOutConfig;
import com.usky.demo.service.vo.MqttDataInfoVO;
import com.usky.demo.util.*;
import org.springframework.context.annotation.Configuration;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

@Service
@Configuration
public class QueryEnergyUnitUsed {
    @Resource
    private MqttOutConfig.MqttGateway mqttGateway;

    static String token = "c19ac221e0504552b6c2ebed4b2b069b";

    /* 除获取token外的所有请求都需要带有token数据，demo中简单起见未做token的保存处理，实际使用中请自行实现 */
    public static void getToken() {
        HashMap<String, String> map = new HashMap<>();
        map.put("operatorSecret", Globals.OPERATOR_SECRET);
        try {
            JSONObject jsonObject = queryData("queryToken", map, null);
            String data = jsonObject.getString("data");
            JSONObject dataObject = JSONObject.parseObject(data);
            token = dataObject.getString("accessToken");
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    //将字符串转换为时间戳
    public static long getStringToDate(String time){
        SimpleDateFormat sf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        Date date = new Date();
        try {
            date = sf.parse(time);
        }catch (ParseException e){
            e.printStackTrace();
        }
        return date.getTime();
    }

    // 查询用能电表统计数据信息
    public void QueryEnergyElectricUsed() {
        printJsonMessage("enter token","QueryEnergyElectricUsed");
        getToken();
        printJsonMessage("end token ","QueryEnergyElectricUsed");

//        String ownerId = "";
//
//        try{
//            JSONObject jsonObject = queryData("queryEnergyUnit", new HashMap<>(), token);
//            String data = jsonObject.getString("data");
//            JSONObject dataObject = JSONObject.parseObject(data);
//            ownerId = dataObject.getString("ownerId");
//            printJsonMessage("ownerId ",ownerId);
//
//        } catch (Exception e){
//            e.printStackTrace();
//        }

        Calendar calendar = Calendar.getInstance();
        calendar.add(Calendar.HOUR,-2);
        String time = new SimpleDateFormat("yyyyMMddHH").format(calendar.getTime());

        HashMap<String, String> map = new HashMap<>();
        map.put("energyUnitId", "1");//用能单位编码
        map.put("energyUnitType","12");//用能单位类型(11：企业，12：单位)
        map.put("energyType","1");//能源类型(1：电，2：水)
        map.put("circleType","1");//统计周期(1：小时，2：日，3：月)
        map.put("dataTime",time);//查询时间(格式 yyyyMMddHH/yyyyMMdd/yyyyMM)
        try {
            JSONObject electricObject = queryData("queryEnergyUnitUsed", map, token);
            String electricData = electricObject.getString("data");
            JSONObject dataObj = JSONObject.parseObject(electricData);
            String dataTime = dataObj.getString("dataTime");
            String energyValue = dataObj.getString("used");

            MqttDataInfoVO mqttDataInfoVO = new MqttDataInfoVO();
            Map<String,Object> map1 = new HashMap<>();
            map1.put("energy_used",energyValue);
            mqttDataInfoVO.setMetrics(map1);
            mqttDataInfoVO.setDevice_id("ysdb0001");
            mqttDataInfoVO.setProduct_id("512_YSNH");
            mqttDataInfoVO.setTimestamp(getStringToDate(dataTime));
            mqttDataInfoVO.setDevice_type("512");

            if(mqttDataInfoVO != null){
                mqttGateway.sendToMqtt("data-collector", JSONArray.toJSON(mqttDataInfoVO).toString());
            }

        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    // 查询用能电表统计数据信息
    public void QueryEnergyWaterUsed() {
        getToken();

//        String ownerId = "";
//
//        try{
//            JSONObject jsonObject = queryData("queryEnergyUnit", new HashMap<>(), token);
//            String data = jsonObject.getString("data");
//            JSONObject dataObject = JSONObject.parseObject(data);
//            ownerId = dataObject.getString("ownerId");
//
//        } catch (Exception e){
//            e.printStackTrace();
//        }

        Calendar calendar = Calendar.getInstance();
        calendar.add(Calendar.HOUR,-2);
        String time = new SimpleDateFormat("yyyyMMddHH").format(calendar.getTime());

        HashMap<String, String> map = new HashMap<>();
        map.put("energyUnitId", "1");//用能单位编码
        map.put("energyUnitType","12");//用能单位类型(11：企业，12：单位)
        map.put("energyType","2");//能源类型(1：电，2：水)
        map.put("circleType","1");//统计周期(1：小时，2：日，3：月)
        map.put("dataTime",time);//查询时间(格式 yyyyMMddHH/yyyyMMdd/yyyyMM)
        try {
            JSONObject electricObject = queryData("queryEnergyUnitUsed", map, token);
            String electricData = electricObject.getString("data");
            JSONObject dataObj = JSONObject.parseObject(electricData);
            String dataTime = dataObj.getString("dataTime");
            String energyValue = dataObj.getString("used");

            MqttDataInfoVO mqttDataInfoVO = new MqttDataInfoVO();
            Map<String,Object> map1 = new HashMap<>();
            map1.put("energy_used",energyValue);
            mqttDataInfoVO.setMetrics(map1);
            mqttDataInfoVO.setDevice_id("yssb0001");
            mqttDataInfoVO.setProduct_id("512_YSNH");
            mqttDataInfoVO.setTimestamp(getStringToDate(dataTime));
            mqttDataInfoVO.setDevice_type("512");

            if(mqttDataInfoVO != null){
                mqttGateway.sendToMqtt("data-collector", JSONArray.toJSON(mqttDataInfoVO).toString());
            }
            printJsonMessage("data-collector",mqttDataInfoVO);

        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 请求数据
     *
     * @param path    请求接口
     * @param dataMap 所需的数据Map
     */
    public static JSONObject queryData(String path, Map<String, String> dataMap, String token) throws Exception {
        // 加密data部分
        String encode = CodeUtil.dataEncode(JSON.toJSONString(dataMap), Globals.DATA_SECRET, Globals.DATA_SECRET_IV);
        /*组装必要参数 start */
        String seq = "0001";
        String timeStamp = new SimpleDateFormat("yyyyMMddHHmmss").format(new Date());
        Map<String, String> map = new HashMap<>();
        map.put("operatorId", Globals.OPERATOR_ID);
        map.put("data", encode);
        map.put("timeStamp", timeStamp);
        map.put("seq", seq);
        /*组装必要参数 end */
        if (encode == null) return null;

        /*生成签名 start*/
        // 为防止+在收发过程中被变成空格，将加密后的密文中的所有空格替换一下
        // 需要签名的参数: operatorId + 加密后的data + 时间戳 + 自增序列
        String signSrc = Globals.OPERATOR_ID + encode.replaceAll(" ", "+") + timeStamp + seq;
        String sig = CodeUtil.getSign(signSrc, Globals.SIGN_KEY);
        //将签名放入参数Map
        map.put("sig", sig);
        /*生成签名 start*/
        /*执行请求，使用可以附加token的doPost方*/
        HttpClientHelper instance = HttpClientHelper.getInstance();
        //token也可以放进参数列表
        String result = instance.doPost(Globals.URL_PREFIX + (path.startsWith("/") ? path : ("/" + path)), map, token);
        if (StringUtil.isEmpty(result)) return null;

        /*解析数据 start*/
        JSONObject jsonObject = JSON.parseObject(result);
        // 失败
        if (!"0".equals(jsonObject.getString("ret"))) {
            printJsonMessage("send Error:", jsonObject);
            return null;
        }
        // 验签，注意生成签名的参数顺序应和发送时一样
        // 为防止'+'在收发过程中被变成' '，将加密后的密文中的所有空格替换一下
        String resultSigStr = jsonObject.getString("operatorId") + jsonObject.getString("data").replaceAll(" ", "+")
                + jsonObject.getString("msg") + jsonObject.getString("ret");
        String resultSig = CodeUtil.getSign(resultSigStr, Globals.SIGN_KEY);
        if (StringUtil.isNotEmpty(jsonObject.getString("sig")) && jsonObject.getString("sig").equals(resultSig)) {
            // 解密数据，需要数据秘钥和秘钥初始化向量
            String data = CodeUtil.dataDecode(jsonObject.getString("data"), Globals.DATA_SECRET, Globals.DATA_SECRET_IV);
            jsonObject.put("data", data);
        }
        /*解析数据 end*/
        // 打印 or 其他操作
        printJsonMessage("Send Message:", map);
        printJsonMessage("Receive Message:", result);
        printJsonMessage("Decode Message:", jsonObject);
        return jsonObject;
    }

    public static void printJsonMessage(String prefix, Object obj) {
        System.out.println(prefix + JsonUtil.JsonFormart(JSON.toJSONString(obj)));
    }
}
